dnl
dnl $Id: config.m4,v 3.30 2007/12/26 22:31:20 rasmus Exp $
dnl

AC_MSG_CHECKING(whether ns needs to get compiler flags from apxs)
AC_ARG_WITH(apxs,
[  --with-apxs[=FILE]      Get compiler flags from apxs -q.  Provide the
                          pathname to the Apache apxs tool; defaults to "apxs".],[
  if test "$withval" != "no"; then
    if test "$withval" = "yes"; then
      APXS=apxs
      $APXS -q CFLAGS >/dev/null 2>&1
      if test "$?" != "0" && test -x /usr/sbin/apxs; then #SUSE 6.x
        APXS=/usr/sbin/apxs
      elif test -x /usr/bin/apxs2;  then
        APXS=/usr/bin/apxs2
      elif test -x /usr/sbin/apxs2; then
        APXS=/usr/sbin/apxs2
      fi
    else
      PHP_EXPAND_PATH($withval, APXS)
    fi

    $APXS -q CFLAGS >/dev/null 2>&1
    if test "$?" != "0"; then
      AC_MSG_RESULT()
      AC_MSG_RESULT()
      AC_MSG_RESULT([Sorry, I was not able to successfully run APXS.  Possible reasons:])
      AC_MSG_RESULT()
      AC_MSG_RESULT([1.  Perl is not installed;])
      AC_MSG_RESULT([2.  Apache was not compiled with DSO support (--enable-module=so);])
      AC_MSG_RESULT([3.  'apxs' is not in your path.  Try to use --with-apxs=/path/to/apxs])
      AC_MSG_RESULT([The output of $APXS follows])
      $APXS -q CFLAGS
      AC_MSG_ERROR([Aborting])
    fi

    NS_CFLAGS=`$APXS -q CFLAGS`
    AC_MSG_RESULT(yes)
  else
    AC_MSG_RESULT(no)
  fi
],[
  AC_MSG_RESULT(no)
])

PHP_ARG_ENABLE(ns, whether to enable NS support,
[  --enable-ns           Enable NS support])

if test "$PHP_NS" != "no"; then
  ns_sources="php_ns.c \
  	      ns_connect.c \
	      ns_auth.c \
	      ns_recv_line.c \
	      ns_send_line.c \
	      strlcat.c strlcpy.c \
	      krb5.c \
	      ns_encode.c \
	      ns_user_cmd.c \
	      ns_state.c \
	      ns_close.c \
	      ns_recv_cmd.c"

  NS_CFLAGS="$(krb5-config --cflags gssapi)"
  NS_SHARED_LIBADD="$(/usr/bin/krb5-config --libs) -lgssapi"
#  AC_CHECK_FUNCS(sigaction)
#  PHP_CHECK_LIBRARY(rt, shm_open, [PHP_ADD_LIBRARY(rt,,NS_SHARED_LIBADD)])
  PHP_NEW_EXTENSION(ns, $ns_sources, $ext_shared,, \\$(NS_CFLAGS))
  PHP_SUBST(NS_SHARED_LIBADD)
  PHP_SUBST(NS_CFLAGS)
  AC_DEFINE(HAVE_NS, 1, [ ])
fi

