/*
** ns.h for netsoul in /tmp/php-5.2.6RC3
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Sat Apr  5 13:16:24 2008 corentin chary
** Last update Sun Apr  6 15:06:18 2008 corentin chary
*/

#ifndef NS_H_
# define NS_H_

# include <stdlib.h>
# include <sys/types.h>
# include <stdarg.h>
# include <stdio.h>

typedef struct	s_ns
{
  char		*user;
  char		*host;
  short		port;
  char		*location;
  char		*group;
  char		*system;
  int		sock;
  char		inbuf[BUFSIZ];
  int		toolong;
  size_t	bufsize;
}		t_ns;

typedef enum	e_cmd
{
  CMD_SALUT = 0,
  CMD_PING,
  CMD_REP,
  CMD_USER_CMD
}		t_cmd;

int	ns_connect(t_ns *ns);
int	ns_auth(t_ns *ns, const char *pass);
void	ns_close(t_ns *ns);

char	*ns_recv_line(t_ns *ns);
ssize_t	ns_send_line(t_ns *ns, const char *fmt, ...);

char	*ns_recv_cmd(t_ns *ns, int timeout);

char	*ns_encode(const char *str);

int	ns_state(t_ns *ns, const char *state);
int	ns_ping(t_ns *ns);

void	ns_user_cmd_msg_user(t_ns *ns, const char *user, const char *msg);
void	ns_user_cmd_who(t_ns *ns, const char *who);
void	ns_user_cmd_watch_log_user(t_ns *ns , const char *user);

char	*ns_receive_cmd(t_ns *ns, int timeout);

#endif /* !NS_H_ */
