/*
** ns_auth.c for phpns in /tmp/ns
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Sun Apr  6 10:22:43 2008 corentin chary
** Last update Sun Apr  6 10:22:44 2008 corentin chary
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "ns.h"
#include "php.h"
#include "php_ini.h"
#include "ext/standard/info.h"
#include "ext/standard/base64.h"
#include "php_ns.h"

#include "krb.h"

int			ns_auth(t_ns *ns, const char *pass)
{
  char			*resp;
  unsigned char		*hash;
  gss_buffer_desc	*token;

  resp = ns_recv_line(ns);
  ns_send_line(ns, "auth_ag ext_user none -");
  resp = ns_recv_line(ns);
  if (strcmp(resp, "rep 002 -- cmd end"))
    return (-1);
  token = krb_get_token(ns->user, pass);
  if (!token)
    return (-1);
  hash = php_base64_encode(token->value, token->length, NULL);
  free(token);
  ns_send_line(ns, "ext_user_klog %s %s %s %s phpsoul", hash,
	       ns->system, ns->location, ns->group);
  efree(hash);
  resp = ns_recv_line(ns);
  if (strcmp(resp, "rep 002 -- cmd end"))
    return (-1);
  return (0);
}
