/*
** ns_connect.c for phpns in /tmp/ns
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Sun Apr  6 10:22:51 2008 corentin chary
** Last update Sun Apr  6 15:18:53 2008 corentin chary
*/

#include <stdlib.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <resolv.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>

#include "ns.h"

static int		sock_connect(const char *host, unsigned short port)
{
  struct sockaddr_in	server;
  struct hostent	*hp;
  int			fd;

  fd = socket(AF_INET, SOCK_STREAM, 0);
  if (fd < 0)
    {
      perror("socket()");
      return (fd);
    }
  hp = gethostbyname(host);
  if (!hp)
    {
      perror("hostname is unknown");
      return (-1);
    }
  memcpy(&server.sin_addr, hp->h_addr, hp->h_length);
  server.sin_port = htons(port);
  server.sin_family = AF_INET;
  if (connect(fd, (struct sockaddr *)&server, sizeof (server)) < 0)
    {
      perror("can't connect to");
      return (-1);
    }
  return (fd);
}

int	ns_connect(t_ns *ns)
{
  ns->sock = sock_connect(ns->host, ns->port);
  if (ns->sock < 0)
    return (-1);
  return (0);
}

