/*
** strsplit.c for ftplib in /home/chary_c/Prog/my_ftp/libxalloc
** 
** Made by corentin chary
** Login   <chary_c@epitech.net>
** 
** Started on  Fri Jan  4 10:31:32 2008 corentin chary
** Last update Sun Apr  6 13:50:36 2008 corentin chary
*/

#include <string.h>
#include <stdio.h>
#include "xalloc.h"

static size_t	count_splits(char *str, char *delim)
{
  char		*p;
  size_t	rows;

  rows = 1;
  while ((p = strpbrk(str, delim)))
    {
      str = p + 1;
      if (!*str)
	break;
      rows++;
      while (*str && strchr(delim, *str))
	str++;
    }
  return (rows);
}

static char	**split(char *str, char *delim, size_t n)
{
  char		*p;
  char		**ret;
  uint		i;
  size_t	len;
  size_t	dlen;

  ret = calloc((n + 1) * sizeof (*ret));
  i = 0;
  dlen = strlen(delim);
  while (i < n)
    {
      p = strpbrk(str, delim);
      if (p)
	len = p - str;
      else
	len = strlen(str);
      ret[i] = malloc(len + 1);
      strncpy(ret[i], str, len);
      ret[i][len] = '\0';
      str = p;
      while (str && *str && strchr(delim, *str))
	str++;
      i++;
    }
  return (ret);
}

char		**strsplit(char *str, char *delim, size_t *rows)
{
  size_t	n;

  n = count_splits(str, delim);
  if (rows)
    *rows = n;
  return (split(str, delim, n));
}
